/************************************************************************
 *									*
 *	gbib.h								*
 *									*
 * This file is for DS_gbib release 1.00				*
 *									*
 * Author: Jarle Strand							*
 * Last change: 15/3-1988						*
 * Copyright: Jarle Strand + Datasekretariatet/KUD			*
 *									*
 ************************************************************************/


/* Graphic modus */

#define	low	(char) 3
#define	med	(char) 2
#define	high	(char) 1

/* Switch */

#define	on	(char) 1
#define	off	(char) 0

/* Penmodes */

#define	replace	(char) 0
#define	reverse	(char) 1

/* Object types */
#define	hollow	(char) 0
#define	solid	(char) 1
#define	pattern	(char) 2

/* Text directions */

#define	hoyre	(char) 0
#define	opp	(char) 1
#define	venstre	(char) 2
#define	ned	(char) 3
#define	right	(char) 0
#define	up	(char) 1
#define	left	(char) 2
#define	down	(char) 3


/* Function prototypes */


void init_graphics();
void cls();
void set_modus(char);
char get_modus();
void define_color(char,char,char,char);
void set_pencolor(char);
char get_pencolor();
void set_backgroundcolor(char);
char get_backgroundcolor();
void set_penmode(char);
char get_penmode();
void set_transparent(char);
char get_transparent();
void set_pattern(char[]);
void set_clip_area(char);
void define_clip_area(int,int,int,int);

extern int Tx,Ty,Tangle;
void Tturn(int);
void Tturnto(int);
void Tmove(int);
void Tmoveto(int,int);
void Tmoveby(int,int);
void Tline(int);
void Tlineto(int,int);
void Tlineby(int,int);
void Tplot();
void Tarc(int,int);
void Tellipse(int,int,char);
void Trectangle(int,int,char);
void Td_line(int,int);
void Td_lineto(int,int,int);
void Td_lineby(int,int,int);
void Tp_line(int);
void Tp_lineto(int,int);
void Tp_lineby(int,int);
void Tp_plot();

void plot(int,int);
void p_plot(int,int);
char point(int,int);
void line(int,int,int,int);
void p_line(int,int,int,int);
void d_line(int,int,int,int,int);
void polygon(char,int[],int[],char);
void rectangle(int,int,int,int,char);
void ellipse(int,int,int,int,char);
void arc(int,int,int,int,int,int);

void B_text(char[],char);
void B_setcursor(int,int);
int  B_get_x();
int  B_get_y();
int  B_char_width(char);
int  B_char_depth(char);
void B_text_size(char,char);
void B_textdir(char);
void B_set_font(char[]);
void B_set_std_font();

void get_block(char[],int,int,int,int);
void put_block(char[],int,int);
void over_block(char[],int,int);
void under_block(char[],int,int);
int  get_blocksize(int,int);
void get_Bblock(char[],int,int,int,int);
void put_Bblock(char[],int,int);
void over_Bblock(char[],int,int);
void under_Bblock(char[],int,int);
int  get_Bblocksize(int,int);

void flood_fill(int,int,char);
void boundary_fill(int,int,char,char);
