(************************************************************************
 *									*
 *		gbib.inc						*
 *									*
 * This file is for DS_gbib release 1.00. MicroSoft Pascal Compiler	*
 *									*
 * Author: Jarle Strand							*
 * Last change: 15/3-1988						*
 * Copyright: Jarle Strand + Datasekretariatet/KUD			*
 *									*
 ************************************************************************)

TYPE
	tekst = LSTRING(255);

CONST
	(* Graphic modus *)
	low = 3;
	med = 2;
	high= 1;

	(* Switch *)
	on  = 1;
	off = 0;

	(* Penmodes *)
	replace = 0;
	reverse = 1;

	(* Object types *)
	hollow = 0;
	solid  = 1;
	pattern = 2;

	(* Text directions *)
	hoyre = 0;
	opp   = 1;
	venstre = 2;
	ned = 3;
	rigth = 0;
	up    = 1;
	left  = 2;
	down  = 3;


(* EXTERNAL DECLARATIONS: *)

VAR [EXTERN] Tx,Ty,Tangle:INTEGER;

PROCEDURE init_graphics; EXTERN;
PROCEDURE cls[C]; EXTERN;
PROCEDURE set_modus(c:BYTE)[C]; EXTERN;
FUNCTION get_modus:BYTE[C]; EXTERN;
PROCEDURE define_color(c,r,g,b:BYTE)[C]; EXTERN;
PROCEDURE set_pencolor(c:BYTE)[C]; EXTERN;
FUNCTION get_pencolor:BYTE[C]; EXTERN;
PROCEDURE set_backgroundcolor(c:BYTE)[C]; EXTERN;
FUNCTION get_backgroundcolor:BYTE[C]; EXTERN;
PROCEDURE set_penmode(c:BYTE)[C]; EXTERN;
FUNCTION get_penmode:BYTE[C]; EXTERN;
PROCEDURE set_transparent(c:BYTE)[C]; EXTERN;
FUNCTION get_transparent:BYTE[C]; EXTERN;
PROCEDURE set_pattern(p:ADSMEM)[C]; EXTERN;
PROCEDURE set_clip_area(c:BYTE)[C]; EXTERN;
PROCEDURE define_clip_area(x1,y1,x2,y2:INTEGER)[C]; EXTERN;

PROCEDURE Tturn(n:INTEGER); EXTERN;
PROCEDURE Tturnto(n:INTEGER); EXTERN;
PROCEDURE Tmove(n:INTEGER); EXTERN;
PROCEDURE Tmoveto(x,y:INTEGER); EXTERN;
PROCEDURE Tmoveby(x,y:INTEGER); EXTERN;
PROCEDURE Tline(n:INTEGER); EXTERN;
PROCEDURE Tlineto(x,y:INTEGER); EXTERN;
PROCEDURE Tlineby(x,y:INTEGER); EXTERN;
PROCEDURE Tplot; EXTERN;
PROCEDURE Tarc(v,r:INTEGER); EXTERN;
PROCEDURE Tellipse(rx,ry:INTEGER;t:BYTE); EXTERN;
PROCEDURE Trectangle(dx,dy:INTEGER;t:BYTE); EXTERN;
PROCEDURE Td_line(n,t:INTEGER); EXTERN;
PROCEDURE Td_lineto(x,y,t:INTEGER); EXTERN;
PROCEDURE Td_lineby(x,y,t:INTEGER); EXTERN;
PROCEDURE Tp_line(n:INTEGER); EXTERN;
PROCEDURE Tp_lineto(x,y:INTEGER); EXTERN;
PROCEDURE Tp_lineby(x,t:INTEGER); EXTERN;
PROCEDURE Tp_plot; EXTERN;

PROCEDURE plot(x,y:INTEGER)[C]; EXTERN;
PROCEDURE p_plot(x,y:INTEGER)[C]; EXTERN;
FUNCTION point(x,y:INTEGER):BYTE[C]; EXTERN;
PROCEDURE line(x1,y1,x2,y2:INTEGER)[C]; EXTERN;
PROCEDURE p_line(x1,y1,x2,y2:INTEGER)[C]; EXTERN;
PROCEDURE d_line(x1,y1,x2,y2,p:INTEGER)[C]; EXTERN;
PROCEDURE polygon(n:BYTE;x,y:ADSMEM; c:BYTE)[C]; EXTERN;
PROCEDURE rectangle(x,y,dx,dy:INTEGER; t:BYTE)[C]; EXTERN;
PROCEDURE ellipse(x,y,rx,ry:INTEGER; t:BYTE)[C]; EXTERN;
PROCEDURE arc(x,y,rx,ry,from_angle,delta:INTEGER); EXTERN;

PROCEDURE B_text(s:tekst;t:BYTE); EXTERN;
PROCEDURE B_setcursor(x,y:INTEGER)[C]; EXTERN;
FUNCTION B_get_x:INTEGER[C]; EXTERN;
FUNCTION B_get_y:INTEGER[C]; EXTERN;
FUNCTION B_char_width(c:CHAR):INTEGER[C]; EXTERN;
FUNCTION B_char_depth(c:CHAR):INTEGER[C]; EXTERN;
PROCEDURE B_text_size(x,y:BYTE)[C]; EXTERN;
PROCEDURE B_textdir(c:BYTE)[C]; EXTERN;
PROCEDURE B_set_font(p:ADSMEM)[C]; EXTERN;
PROCEDURE B_set_std_font[C]; EXTERN;

PROCEDURE get_block(m:ADSMEM; x,y,dx,dy:INTEGER)[C]; EXTERN;
PROCEDURE put_block(m:ADSMEM; x,y:INTEGER)[C]; EXTERN;
PROCEDURE over_block(m:ADSMEM; x,y:INTEGER)[C]; EXTERN;
PROCEDURE under_block(m:ADSMEM; x,t:INTEGER)[C]; EXTERN;
PROCEDURE get_blocksize(dx,dy:INTEGER)[C]; EXTERN;
PROCEDURE get_Bblock(m:ADSMEM; x,y,dx,dy:INTEGER)[C]; EXTERN;
PROCEDURE put_Bblock(m:ADSMEM; x,y:INTEGER)[C]; EXTERN;
PROCEDURE over_Bblock(m:ADSMEM; x,y:INTEGER)[C]; EXTERN;
PROCEDURE under_Bblock(m:ADSMEM; x,t:INTEGER)[C]; EXTERN;
PROCEDURE get_Bblocksize(dx,dy:INTEGER)[C]; EXTERN;

PROCEDURE flood_fill(x,y:INTEGER; f:BYTE)[C]; EXTERN;
PROCEDURE boundary_fill(x,y:INTEGER; b,f:BYTE)[C]; EXTERN;
