(************************************************************************
 *                                                                      *
 *    DS_gbib for Turbo Pascal 3.01A for Tiki 100 under MS-DOS 2.11     *
 *                                                                      *
 *                        ver. 1.0                                      *
 *                                                                      *
 *  Copyright: Frigitt av KUD/Datasekretariatet som Public Domain       *
 *  Siste endring: 1/6-1988                                             *
 *  Laget av: Jarle Strand                                              *
 *                                                                      *
 ************************************************************************)


CONST
  low = 3;
  med = 2;
  high = 1;

  on = 1;
  off = 0;

  replace = 0;
  reverse = 1;

  hollow = 0;
  solid = 1;
  pattern = 2;

  hoyre = 0;
  opp = 1;
  venstre = 2;
  ned = 3;
  right = 0;
  up = 1;
  left = 2;
  down = 3;


TYPE
  str255 = String(.255.);


VAR
  GBCB: Array[0..6] OF INTEGER;
  GBseg,GBofs: Integer;
  GBs: str255;


PROCEDURE init_graphics;
BEGIN

  IF ( MemW[0:672] OR Memw[0:674] ) = 2545 THEN BEGIN
    Writeln;
    Writeln('Du m} laste opp gbib.exe f|rst');
    Writeln;
    halt;
  END;

  GBseg := Seg(GBCB);
  GBofs := Ofs(GBCB);

  GBCB[0] := 0;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

PROCEDURE cls;
BEGIN
  GBCB[0] := 1;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

PROCEDURE set_modus(m:Byte);
BEGIN
  GBCB[0] := 2;
  GBCB[1] := m;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

FUNCTION get_modus:BYTE;
BEGIN
  GBCB[0] := 3;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
  get_modus := GBCB[0];
END;

PROCEDURE define_color(n,r,g,b:BYTE);
BEGIN
  GBCB[0] := 4;
  GBCB[1] := n;
  GBCB[2] := r;
  GBCB[3] := g;
  GBCB[4] := b;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

PROCEDURE set_pencolor(n:BYTE);
BEGIN
  GBCB[0] := 5;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

FUNCTION get_pencolor:BYTE;
BEGIN
  GBCB[0] := 6;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
  get_pencolor := GBCB[0];
END;

PROCEDURE set_backgroundcolor(n:BYTE);
BEGIN
  GBCB[0] := 7;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

FUNCTION get_backgroundcolor:BYTE;
BEGIN
  GBCB[0] := 8;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
  get_backgroundcolor := GBCB[0];
END;

PROCEDURE set_penmode(m:BYTE);
BEGIN
  GBCB[0] := 9;
  GBCB[1] := m;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

FUNCTION get_penmode:BYTE;
BEGIN
  GBCB[0] := 10;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
  get_penmode := GBCB[0];
END;

PROCEDURE set_transparent(n:BYTE);
BEGIN
  GBCB[0] := 11;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
END;

FUNCTION get_transparent: BYTE;
BEGIN
  GBCB[0] := 12;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  get_transparent := GBCB[0];
END;

PROCEDURE set_pattern(VAR p);
BEGIN
  GBCB[0] := 13;
  GBCB[1] := Seg(p);
  GBCB[2] := Ofs(p);
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE set_clip_area(s:BYTE);
BEGIN
  GBCB[0] := 14;
  GBCB[1] := s;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE define_clip_area(x1,y1,x2,y2:INTEGER);
BEGIN
  GBCB[0] := 15;
  GBCB[1] := x1;
  GBCB[2] := y1;
  GBCB[3] := x2;
  GBCB[4] := y2;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tturn(n:INTEGER);
BEGIN
  GBCB[0] := 16;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tturnto(n:INTEGER);
BEGIN
  GBCB[0] := 17;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tmove(n:INTEGER);
BEGIN
  GBCB[0] := 18;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tmoveto(x,y:INTEGER);
BEGIN
  GBCB[0] := 19;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tmoveby(dx,dy:INTEGER);
BEGIN
  GBCB[0] := 20;
  GBCB[1] := dx;
  GBCB[2] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tline(n:INTEGER);
BEGIN
  GBCB[0] := 21;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tlineto(x,y:INTEGER);
BEGIN
  GBCB[0] := 22;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tlineby(dx,dy:INTEGER);
BEGIN
  GBCB[0] := 23;
  GBCB[1] := dx;
  GBCB[2] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tplot;
BEGIN
  GBCB[0] := 24;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tarc(v,r: INTEGER);
BEGIN
  GBCB[0] := 25;
  GBCB[1] := v;
  GBCB[2] := r;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tellipse(rx,ry: INTEGER; t: BYTE);
BEGIN
  GBCB[0] := 26;
  GBCB[1] := rx;
  GBCB[2] := ry;
  GBCB[3] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Trectangle(dx,dy:INTEGER);
BEGIN
  GBCB[0] := 27;
  GBCB[1] := dx;
  GBCB[2] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Td_line(n,t:INTEGER);
BEGIN
  GBCB[0] := 28;
  GBCB[1] := n;
  GBCB[2] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Td_lineto(x,y,t:INTEGER);
BEGIN
  GBCB[0] := 29;
  GBCB[1] := x;
  GBCB[2] := y;
  GBCB[3] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Td_lineby(dx,dy,t:INTEGER);
BEGIN
  GBCB[0] := 30;
  GBCB[1] := dx;
  GBCB[2] := dy;
  GBCB[3] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tp_line(n:INTEGER);
BEGIN
  GBCB[0] := 31;
  GBCB[1] := n;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tp_lineto(x,y:INTEGER);
BEGIN
  GBCB[0] := 32;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tp_lineby(dx,dy:INTEGER);
BEGIN
  GBCB[0] := 33;
  GBCB[1] := dx;
  GBCB[2] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE Tp_plot;
BEGIN
  GBCB[0] := 34;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE plot(x,y:INTEGER);
BEGIN
  GBCB[0] := 35;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE p_plot(x,y:INTEGER);
BEGIN
  GBCB[0] := 36;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

FUNCTION point(x,y:INTEGER):BYTE;
BEGIN
  GBCB[0] := 37;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  point := GBCB[0];
END;

PROCEDURE line(x1,y1,x2,y2:INTEGER);
BEGIN
  GBCB[0] := 38;
  GBCB[1] := x1;
  GBCB[2] := y1;
  GBCB[3] := x2;
  GBCB[4] := y2;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE p_line(x1,y1,x2,y2:INTEGER);
BEGIN
  GBCB[0] := 39;
  GBCB[1] := x1;
  GBCB[2] := y1;
  GBCB[3] := x2;
  GBCB[4] := y2;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE d_line(x1,y1,x2,y2,p:INTEGER);
BEGIN
  GBCB[0] := 40;
  GBCB[1] := x1;
  GBCB[2] := y1;
  GBCB[3] := x2;
  GBCB[4] := y2;
  GBCB[5] := p;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE polygon(n: BYTE; VAR x,y; t: BYTE);
BEGIN
  GBCB[0] := 41;
  GBCB[1] := n;
  GBCB[2] := Seg(x);
  GBCB[3] := Ofs(x);
  GBCB[4] := Seg(y);
  GBCB[5] := Ofs(y);
  GBCB[6] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE rectangle(x,y,dx,dy:INTEGER; t:BYTE);
BEGIN
  GBCB[0] := 42;
  GBCB[1] := x;
  GBCB[2] := y;
  GBCB[3] := dx;
  GBCB[4] := dy;
  GBCB[5] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE ellipse(x,y,rx,ry:INTEGER; t:BYTE);
BEGIN
  GBCB[0] := 43;
  GBCB[1] := x;
  GBCB[2] := y;
  GBCB[3] := rx;
  GBCB[4] := ry;
  GBCB[5] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE arc(x,y,rx,ry,from_angle,delta:INTEGER);
BEGIN
  GBCB[0] := 44;
  GBCB[1] := x;
  GBCB[2] := y;
  GBCB[3] := rx;
  GBCB[4] := ry;
  GBCB[5] := from_angle;
  GBCB[6] := delta;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE B_text(s: str255; t:BYTE);
BEGIN
  GBs := s;
  GBCB[0] := 45;
  GBCB[1] := Seg(GBs);
  GBCB[2] := Ofs(GBs);
  GBCB[3] := t;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE B_setcursor(x,y:INTEGER);
BEGIN
  GBCB[0] := 46;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

FUNCTION B_get_x:INTEGER;
BEGIN
  GBCB[0] := 47;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  B_get_x := GBCB[0];
END;

FUNCTION B_get_y:INTEGER;
BEGIN
  GBCB[0] := 48;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  B_get_y := GBCB[0];
END;

FUNCTION B_get_width(c:CHAR):INTEGER;
BEGIN
  GBCB[0] := 49;
  GBCB[1] := Ord(c);
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );
  B_get_width:= GBCB[0];
END;

FUNCTION B_get_depth(c:CHAR):INTEGER;
BEGIN
  GBCB[0] := 50;
  GBCB[1] := Ord(c);
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  B_get_depth := GBCB[0];
END;

PROCEDURE B_text_size(x,y:BYTE);
BEGIN
  GBCB[0] := 51;
  GBCB[1] := x;
  GBCB[2] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE B_textdir(r:BYTE);
BEGIN
  GBCB[0] := 52;
  GBCB[1] := r;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE B_set_font(VAR p);
BEGIN
  GBCB[0] := 53;
  GBCB[1] := Seg(p);
  GBCB[2] := Ofs(p);
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE B_set_std_font;
BEGIN
  GBCB[0] := 54;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE get_block(VAR m; x,y,dx,dy:INTEGER);
BEGIN
  GBCB[0] := 55;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  GBCB[5] := dx;
  GBCB[6] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE put_block(VAR m; x,y: INTEGER);
BEGIN
  GBCB[0] := 56;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE over_block(VAR m; x,y: INTEGER);
BEGIN
  GBCB[0] := 57;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE under_block(VAR m; x,y:INTEGER);
BEGIN
  GBCB[0] := 58;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

FUNCTION get_blocksize(dx,dy:INTEGER):INTEGER;
BEGIN
  GBCB[0] := 59;
  GBCB[1] := dx;
  GBCB[2] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  get_blocksize := GBCB[0];
END;

PROCEDURE get_Bblock(VAR m; x,y,dx,dy:INTEGER);
BEGIN
  GBCB[0] := 60;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  GBCB[5] := dx;
  GBCB[6] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE put_Bblock(VAR m; x,y: INTEGER);
BEGIN
  GBCB[0] := 61;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE over_Bblock(VAR m; x,y: INTEGER);
BEGIN
  GBCB[0] := 62;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE under_Bblock(VAR m; x,y:INTEGER);
BEGIN
  GBCB[0] := 63;
  GBCB[1] := Seg(m);
  GBCB[2] := Ofs(m);
  GBCB[3] := x;
  GBCB[4] := y;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

FUNCTION get_Bblocksize(dx,dy:INTEGER):INTEGER;
BEGIN
  GBCB[0] := 64;
  GBCB[1] := dx;
  GBCB[2] := dy;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  get_Bblocksize := GBCB[0];
END;

PROCEDURE flood_fill(x,y:INTEGER; f:BYTE);
BEGIN
  GBCB[0] := 65;
  GBCB[1] := x;
  GBCB[2] := y;
  GBCB[3] := f;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

PROCEDURE boundary_fill(x,y:INTEGER; b,f:BYTE);
BEGIN
  GBCB[0] := 66;
  GBCB[1] := x;
  GBCB[2] := y;
  GBCB[3] := b;
  GBCB[4] := f;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
END;

FUNCTION Tx:INTEGER;
BEGIN
  GBCB[0] := 67;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  Tx := GBCB[0];
END;

FUNCTION Ty:INTEGER;
BEGIN
  GBCB[0] := 68;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  Ty := GBCB[0];
END;

FUNCTION Tangle:INTEGER;
BEGIN
  GBCB[0] := 69;
  inline(
  $8B / $1E / GBseg /
  $8B / $0E / GBofs /
  $CD / $A8 );  
  Tangle := GBCB[0];
END;
